#!/bin/sh
#
# MartiniB #
#
#

[ ! $1 ] && SatPosToDo="*" || SatPosToDo=$1

E2conf=/etc/enigma2/settings
Services=/etc/enigma2/lamedb

#doTransponderCleanup=1

foo="$0"
crntNamePath=${foo%.*}
crntNameTXT=$crntNamePath".txt"
crntNameExt=${foo##*/}
crntNameShort=${crntNameExt%.*}
fileCmd=/tmp/"$crntNameShort".CMD
#fileLog=/tmp/"$crntNameShort".Log
fileTuneFailed=$crntNamePath".TuneFailed"
fileTuneOK=$crntNamePath".TuneOK_"`date +%y%m%d`

[ -e /etc/enigma2/settings ] && [ -e /etc/enigma2/lamedb ] || exit

[ -e $fileTuneFailed ] || echo -e "#\n# Tune Failed list:\n#\n"SatPos"\t"Frequency"\t"Symbolrate"\t"Transponder-ID"\t\t"Date-Time>$fileTuneFailed
[ -e $fileTuneOK ] || echo -e "#\n# Tune OK list:\n#\n"SatPos"\t"Frequency"\t"Symbolrate"\t"Transponder-ID"\t\t"Signal-Info"\t"SNR"\t"ACG"\t"BER>$fileTuneOK

FreePort=80
DOCMD1="wget -O $fileCmd -q http://localhost:$FreePort/web"
DOCMD2=$DOCMD1/remotecontrol?command=

grep -qs encoder /proc/stb/avs/0/input|| WereInIdle=1

if [ "$WereInIdle" ]; then
	# Wakeup form Standby
	$DOCMD1/powerstate?newstate=4
	$DOCMD1/vol?set=set0
	$DOCMD1/vol?set=down
	#echo "00">/proc/stb/fp/fan_vlt
fi

PreviousOkServiceRef=1:0:1:1897:D:55:300000:0:0:0:
$DOCMD1/zap?sRef=$PreviousOkServiceRef
sleep 2

RescanTransponder () {
	[ "$doTransponderCleanup" = "1" ] && [ "$dvbCTS" = "s" ] && [ -e /usr/script/ManualScanMenu.sh ] && /usr/script/ManualScanMenu.sh scan+exit
}

ZapToService () {
	#[ "$WereInIdle" ] && echo "00">/proc/stb/fp/fan_vlt
	$DOCMD1/zap?sRef=$ServiceRef
	Symbolrate=`echo $line| awk {'print $9'}`
	Symbolrate=$((Symbolrate / 1000))
	if [ "$Symbolrate" -ge "20000" ]; then
		sleep 3
	elif [ "$Symbolrate" -ge "10000" ]; then
		sleep 4
	elif [ "$Symbolrate" -ge "9000" ]; then
		sleep 6
	elif [ "$Symbolrate" -ge "8000" ]; then
		sleep 8
	elif [ "$Symbolrate" -ge "7000" ]; then
		sleep 10
	elif [ "$Symbolrate" -ge "6000" ]; then
		sleep 12
	elif [ "$Symbolrate" -ge "5000" ]; then
		sleep 14
	elif [ "$Symbolrate" -ge "4000" ]; then
		sleep 16
	elif [ "$Symbolrate" -ge "3000" ]; then
		sleep 18
	else
		sleep 20
	fi
	TryCounter="1"
	SignalInfo="" SignalInfoSNR="-" SignalInfoACG="-" SignalInfoBER="-"
	while [ ! "$SignalInfo" ]; do
		$DOCMD1/signal
		sleep 1
		sed -e ':a;N;$!ba;s/\n/\ /g' -e s#[[:space:]]##g $fileCmd>$fileCmd.singleline
		SignalInfo=`grep "<e2snrdb>" $fileCmd.singleline| sed -e 's/.*<e2snrdb>//' -e 's/<.*//' -e 's/.*\/.*//' -e 's/dB/\ dB/'`
		if [ ! "$SignalInfo" ]; then
			TryCounter=$((TryCounter + 1))
			if [ "$TryCounter" -ge "3" ]; then
				SignalInfo="0"
			else
				# Wakeup form Standby
				$DOCMD1/powerstate?newstate=4
				sleep 2
			fi
		else
			SignalInfoSNR=`grep "<e2snr>" $fileCmd.singleline| sed -e 's/.*<e2snr>//' -e 's/<.*//'`
			SignalInfoACG=`grep "<e2acg>" $fileCmd.singleline| sed -e 's/.*<e2acg>//' -e 's/<.*//'`
			SignalInfoBER=`grep "<e2ber>" $fileCmd.singleline| sed -e 's/.*<e2ber>//' -e 's/<.*//'`
		fi
	done
	SignalInfo2=${SignalInfo%.*}
	Freq=`echo $line| awk {'print $2'}`
	case "$dvbCTS" in
		s)	Pol=" "`echo $line| awk {'print $3'}| sed -e s#0#H# -e s#1#V#`
			Freq=`echo $Freq| sed -e s#[0-9][0-9]#\&\.#`$Pol;;
		*)	Pol=""
			Freq=$((Freq / 100));;
	esac
	[ "$SignalInfo2" -ge "0" -a "$SignalInfo2" -le "9" ] && SignalInfo=" "$SignalInfo
	echo -e "$SignalInfo\t"$satPosE2"\t"$Freq"\t"$Symbolrate"\t"$TransponderID"\t"$SignalInfoSNR"\t"$SignalInfoACG"\t"$SignalInfoBER
	if [ "$SignalInfo2" -le "4" ] || [ "$SignalInfo2" -gt "25" ]; then
		echo -e $satPosE2"\t"$Freq"\t"$Symbolrate"\t\t"$TransponderID"\t"`date +%y.%m.%d.\ %H:%M:%S`>>$fileTuneFailed
		$DOCMD1/zap?sRef=$PreviousOkServiceRef
		sleep 2
	else
		echo -e $satPosE2"\t"$Freq"\t"$Symbolrate"\t\t"$TransponderID"\t"$SignalInfo"\t"$SignalInfoSNR"\t"$SignalInfoACG"\t"$SignalInfoBER>>$fileTuneOK
		PreviousOkServiceRef=$ServiceRef
		RescanTransponder
	fi
	$DOCMD2"174"
	$DOCMD2"174"
#exit
}

for line in `grep -E "^........:....:....$|^[[:space:]][stc] .*:.*:.*:.*:.*:.*:" /etc/enigma2/lamedb| sed -e '/^........:....:....$/N;s/\n//' -e s/:/\ /g| awk '{print substr($1,1,4)" "substr($5,1,5)" "$7" "$0}'| sort| sed s/[[:space:]]/\_/g`; do

#0e08 12723 0 0e0831b3 0002 0001 s 12723000 27500000 0 3 -8 0 0
#0e08 12735 1 0e08b1bf 0001 1111 s 12735000 8800000 1 4 -8 0 0
#eeee 53000 2 eeee0000 13ec 21ac t 530000000 0 2 0 1 1 3 0 0 0
#eeee 55400 1 eeee0000 14b4 21ac t 554000000 0 1 0 2 1 1 0 0 0

	line=`echo $line| sed s/\_/\ /g`
	TransponderID=`echo $line| awk '{print $4":"$5":"$6}'`
	if grep -qs "[[:space:]]$TransponderID[[:space:]]" "$fileTuneFailed" ||
	   grep -qs "[[:space:]]$TransponderID[[:space:]]" "$fileTuneOK"; then
		TransponderID=""
	fi
	if [ "$TransponderID" ]; then
		dvbCTS=`echo $line| awk {'print $7'}`
		case "$dvbCTS" in
			c|t) satPos=dvb$dvbCTS satPosE2=$satPos;;
			s) satPos=`echo $line| awk {'print $12'}`
			   [ "$satPos" -lt 0 ] && satPosE2=$((3600 + satPos)) || satPosE2="$satPos";;
			*) echo error in Read SatPos from $line
			   break;;
		esac
		if [ ! "$satPosE2" = "$satPosLastCheck" ]; then
			if [ "$dvbCTS" = "s" ] && grep -qs ".sat.$satPosE2." "$E2conf"; then
				satPosInst=1
			elif [ "$dvbCTS" = "c" ] && grep -qs "DVB-C" /proc/bus/nim_sockets; then
				satPosInst=1
			elif [ "$dvbCTS" = "t" ] && grep -qs "DVB-T" /proc/bus/nim_sockets; then
				satPosInst=1
			else
				satPosInst=0
			fi
			if [ "$satPosInst" = "1" ]; then
				case "$satPosE2" in
					#*)
					#192)
					#3592)
					$SatPosToDo|$2|$3|$4|$5|$6|$7|$8|$9)
						satPosInst=1;;
					*)
						satPosInst="skip";;
				esac
			fi
			satPosLastCheck="$satPosE2"
			echo -e satPosE2: "$satPosE2\t\t\t" satPosInst: "$satPosInst"
		fi
		if [ "$satPosInst" = "1" ]; then

# type 1 = digital television service
# type 4 = nvod reference service (NYI)
# type 17 = MPEG-2 HD digital television service
# type 22 = advanced codec SD digital television
# type 24 = advanced codec SD NVOD reference service (NYI)
# type 25 = advanced codec HD digital television
# type 27 = advanced codec HD NVOD reference service (NYI)
# type 2 = digital radio sound service
# type 10 = advanced codec digital radio sound service

			TransponderServices=`grep "^....:$TransponderID:.*:0" "$Services"`
			if [ "$TransponderServices" ]; then
				ServiceID=""
				for ServiceType in 1 25 17 22 24 27 4 25 130 133 2 *; do
					for Service in $TransponderServices; do
						case "$Service" in
							*:*:*:*:$ServiceType:0) ServiceID=`echo $Service| sed -e s#:.*##` break;;
						esac
					done
					if [ "$ServiceID" ]; then
						ServiceRef=1:0:1:"$ServiceID":`echo $line| awk '{print $5":"$6":"$4}'`:0:0:0
						ZapToService
						break
					fi
				done
			fi
		fi
	fi
done

# send to Standby / Idle
[ "$WereInIdle" ] && $DOCMD1/powerstate?newstate=5
